'the fail patch-and-pack script!
'usage rule:
'- set the path to xdelta and zip
'- make sure xdelta exec name is xdelta3.exe
'- only use alphanumeric, dash ("-") and underscore ("_") for prefix
'- be smart and make sure you entered correct input or there will be errors (no checking yet, lol)
'- licensed under ISC license :o

const zip = "C:\Program Files\7-Zip\7z.exe" 
const xdelta = "d:\edho\desktop\xdelta3.exe"

sub run(byval paramz)
	dim shell
	set shell = createobject("wscript.shell")
	shell.run paramz, 1, true
end sub

function addpath(inz)
	addpath = path & "\" & inz
end function

function quotez(inz)
	quotez = chr(34) & inz & chr(34)
end function


dim path
dim file_old
dim file_new
dim pref
path = InputBox("Input folder")
file_old = InputBox("Old file")
file_new = InputBox("New file")
pref = InputBox("Prefix")

path_old = quotez(addpath(file_old))
path_new = quotez(addpath(file_new))
patchfile = quotez(addpath(pref & ".vcdiff"))
batchfile = addpath(pref & ".bat")

'create patch
run(xdelta & " -e -s " & path_old & " " & path_new & " " & patchfile)

'create batch
Dim thebatch, thefile, writefilez
thebatch = "xdelta3 -d -s " & quotez(file_old) & " " & quotez(pref & ".vcdiff") & " " & quotez(file_new) & vbCr & vbLf & "@pause"
Set thefile = CreateObject("Scripting.FileSystemObject")
Set writefilez = thefile.createTextFile(batchfile, True)
writefilez.WriteLine(thebatch)
writefilez.Close

'packing
run(quotez(zip) & " a " & quotez(addpath(pref & ".zip")) & " " & quotez(xdelta) & " " & patchfile & " " & quotez(batchfile))

'cleanup
thefile.deletefile addpath(pref & ".vcdiff")
thefile.deletefile batchfile